import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Shot here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Shot extends Actor
{
    /**
     * Act - do whatever the Shot wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
private int angle;



    /**
     * Constructor for a Shot. You must specify the ship the shot comes from.
     */
    public Shot(int angle)
    {
        this.angle = angle;
    }

    /**
     * Act - do whatever the Shot wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        setRotation(angle);
        
        int ypos = getY();
        int xpos = getX();
        
        if ((xpos==0)||(xpos==getWorld().getWidth()-1)||(ypos==0)||(ypos==getWorld().getHeight()-1)){
            getWorld().removeObject(this);
        }else
        {

        xpos = xpos +  (int) Math.round(Math.cos(angle * Math.PI / 180)*10);
            ypos = ypos +  (int) Math.round(Math.sin(angle * Math.PI / 180)*10);
            setLocation(xpos, ypos);
            Turtle tortue = (Turtle) getOneIntersectingObject(Turtle.class);
            if (tortue != null) {
                // We've hit an asteroid!
                //getWorld().removeObject(tortue);
                Sand sand = (Sand) getWorld();
                if (tortue.isFly){ 
                    tortue.setImage("turtle.png");
                    
                    tortue.isFly = false;
                    sand.setProba (sand.getProba() - 2); 
                }else{
                    sand.removeObject(tortue);
                    sand.setProba (sand.getProba() + 1);
                }
                getWorld().removeObject(this);
            }
        }
        
        
    }
       
}
